\section{Motivation for the Survey}
\label{Sec:Motiv}
%Short intro to EEHPCWG EPA JSRM
The investigations of SCs and their ESPs in both the United States and Europe
suggested that fine and course grained power management as well as job 
scheduling were approaches that sites might use to manage their power in 
response to requests from their electricity service providers\cite{Bates2015}.
In response to this insight and a general recognition of a strong interest in 
predicting and managing power usage for HPC data centers for many reasons, the 
\EEHPCWG has formed an \EPAJSRM team. 
It is recognized that lessons learned and best practices are being gained in sites that have deployed 
energy aware resource management and job scheduling software that relies on power
monitoring hardware.
This team is chartered to capture those lessons and best practices.

%With ongoing investigations at the EEHPCWG the working group had previously
%identified how supercomputing centers in the United States\cite{Bates2015} and
%Europe\cite{Patki2016}.
%The approaches taken by centers can be split in two categories:
%\begin{inparaenum}[1)]
%    \item approaches that involve the supercomputing center's physical plant,
%    and
%    \item approaches that involve controlling characteristics of the
%    supercomputers themselves.
%\end{inparaenum}
%The first category considers practices such as lighting control and thermal
%management.
%The second category considers practices such as fine-grained power management
%of system components (e.g., controlling individual CPUs or memory.),
%coarse-grained power management (e.g., power capping),
%load shifting (e.g., moving part of a workload to another facility that has
%more power available), or job scheduling techniques (e.g., understanding
%the power profiles of applications and queuing them based on those profiles
%to achieve some overall power or energy objective, such as recognizing that
%increasing the number of computational nodes dedicated to a job might increase
%the job's power consumption but might decrease the job's overall energy
%consumption by allowing the job to be completed in less time).
%
%The properties of the first category do scale less well with the general system
%size and their impact is limited to minimizing outside system usage when
%looking at metrics such as PUE.
%Short intro to Job Scheduler and Resource Managers

\subsection{Job Schedulers and Resource Manager}

Throughout this paper we refer to two types of system software that we
specifically define here.
Job schedulers allow high-performance computing users to efficiently share the
computing resources that comprise an HPC system.
Users submit batch jobs into one or more batch queues that are defined within
the job scheduler.
The job scheduler examines the overall set of pending work waiting to run on
the computer and makes decisions about which jobs to place next onto the
computational nodes within the computer.
Generally speaking, the job scheduler attempts to optimize some characteristic
such as overall system utilization or fast access to resources for some subset
of batch jobs within the computing center's overall workload.
The various queues that are defined within the job scheduler may be designated
as having higher or lower priorities and may be restricted to some subset of
the center's users, thus allowing the job scheduler to understand distinctions
of importance of certain jobs within the overall workflow.


To carry out its work, a job scheduler typically interacts with one or more
resource managers. A resource manager is a piece of system software that has privileged ability to control various resources within a datacenter.
These resources can include things such as the physical nodes that make up a
high-performance computer's computational resources; disks, disk channels, or
burst buffer hardware that comprise I/O resources;
or network interfaces, network channels, or switches that  comprise
interconnect resources.
For example, a job scheduler might use resource management software to
configure the processing cores, memory, disk, and networking resources within
one or more computational nodes in accordance with the requested resources for
a specific batch job prior to launching that job onto the allocated
computational nodes.

Finally, in some cases, resource management software might have the ability to
actuate pieces of the physical plant that are responsible for delivering
electricity to the datacenter or cooling the datacenter.

%This still needs change (Talked to Sid for replacement with insideHPC article figures!)
\begin{figure*}[ht]
\centering
\includegraphics[width=1.0\textwidth]{files/EPA-JSRM-solutions.jpg}
\caption{Interactions among multiple components that make up a typical
\EPAJSRM (Energy and Power Aware Job Scheduling and Resource Management)
solution.}
\label{fig:EPA_JSRM_solutions}
\end{figure*}

This paper considers the synthesized use of job schedulers and resource
managers to provide energy and power aware job scheduling and resource
management capabilities within a high-performance computing datacenter.
Figure~\ref{fig:EPA_JSRM_solutions} presents an overview of the different 
components that may participate in such a solution.
As shown, depending on the complexity of the implementation, the tasks of an
\EPAJSRM solution can be divided into four functional categories - the
monitoring and control of energy/power consumed by the resources, and their
availability.
Energy/Power `monitoring' techniques complement traditional resource management
of processors, memory, nodes, disks, and networks.
The `control' of  energy/power is heavily dependent on telemetry sensors that
are responsible for constantly monitoring the activity of the system resources.
Examples of such control techniques could range from simple human-controlled
actuation of processor dynamic voltage and frequency settings to reduce power
to much more complex scenarios where the job scheduler has detailed historical
knowledge of job characteristics and schedules multiple jobs simultaneously in
a way that optimizes for certain energy- or power-specific objectives.
Because system-wide software agents like the job scheduler have access to
details of a supercomputing center's entire workload, and can potentially apply
advanced data analytics to the problem, they have the potential for improving
the energy and power consumption of supercomputers in ways that are unlikely to
be possible for human-controlled processes.
Accordingly, we expect that a trend in coming years will be to have system-wide
techniques play an increasing role in these endeavors. 
Due to the previous absence of a general overview of EPA solutions employed, 
actual usage and benefits were only known within individual centers.

\subsection{New dedicated \EPAJSRM team.}

In mid-2016, the \EEHPCWG formed a team focused on energy and power management
through the use of job scheduling, resource management, and associated tools.
The Energy and Power Aware Job Scheduling and Resource Management (\EPAJSRM)
team is comprised of approximately 70 members from supercomputing centers,
various academic and laboratory research centers, and the vendor community,
particularly focusing on job scheduling and resource management software
vendors and system integrators.
Most of the members are from North America and Europe, however there are
members from Asia as well.

During its work, the team identified a number of supercomputing centers that
have developed, or are currently developing, technologies that use \EPAJSRM
techniques on one or more large-scale systems.
%9/7 ? Nine out of seven? Is an explanation why 2 dropped out needed?
Overall, eleven sites were identified and nine sites agreed to participate in a
survey that asked questions about each site's supercomputer installation,
typical utilization metrics and the types of jobs the site typically runs, and
details of the use of \EPAJSRM techniques employed by the site.
After examining responses to the survey questionnaire from each site, a
three-person sub-team interviewed personnel from the site to clarify details in
their written survey responses or to ask for further technical details of
responses that seemed especially noteworthy.
The goal is to present a high-level evaluation of these survey responses,
including unique characteristics of individual sites as well as common 
characteristics across sites.
Based on this evaluation, the objective is to present recommendations for system 
software researchers and scheduler vendors who are working in this area in an 
effort to help guide these endeavors.
%How to best say that this will be part of the upcoming work!?

%%% KTP -- Moving this to the next section, Selection.tex
%%%To the best of our knowledge, the eleven sites that were studied comprise the 
%%%entire set of supercomputing centers that have developed or are actively 
%%%involved in developing \EPAJSRM technology for large-scale deployment, however 
%%%the \EEHPCWG team is open to expanding this set based on feedback to this paper.
%To the best of our knowledge, the sites that were studied comprise the set of
%centers that are actively involved in developing \EPAJSRM techniques for
%large-scale deployment, however the \EEHPCWG team is open to expanding this
%set based on feedback to this paper.
